#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/shm.h>
#include "defs.h"

#define MAXMSG 4096
#define MAXOPEN 20
#define BADADDR (char *) (-1)

static BOOLEAN findinfo(key,sndsidp,rcvsidp,addrp,segidp)
int key;
int *sndsidp,*rcvsidp,*segidp;
char **addrp;
{
	static struct {
		int key;
		int sndsid;
		int rcvsid;
		char *addr;
		int segid;
	} sems[MAXOPEN];
	int i,avail;
	extern int errno;
	char *shmat();
	avail=-1;
	for (i=0;i<MAXOPEN;i++) {
		if (sems[i].key==key) {
			*sndsidp=sems[i].sndsid;
			*rcvsidp=sems[i].rcvsid;
			*segidp=sems[i].segid;
			*addrp=sems[i].addr;
			return(TRUE);
		}
		if (sems[i].key==0 && avail==-1)
			avail=i;
	}
	if (avail==-1) {
		errno=0;
		return(FALSE);
	}
	sems[avail].key=key;
	*sndsidp=sems[avail].sndsid=semtran(key);
	*rcvsidp=sems[avail].rcvsid=semtran(key+10000);
V(sems[avail].sndsid);
	if ((*segidp=sems[avail].segid=shmget((key_t)key,MAXMSG,0666|IPC_CREAT))==-1)
		return(FALSE);
	if ((*addrp=sems[avail].addr=shmat(*segidp,0,0))==BADADDR)
		return(FALSE);
	return(TRUE);
}

BOOLEAN send(dstkey,buf,nbytes)
int dstkey;
char *buf;
int nbytes;
{
	int sndsid,rcvsid,segid;
	char *addr;

	if (!findinfo(dstkey,&sndsid,&rcvsid,&addr,&segid))
		return(FALSE);
	if (nbytes>MAXMSG)
		nbytes=MAXMSG;
	P(sndsid);
	memcpy(addr,buf,nbytes);
	V(rcvsid);
	return(TRUE);
}

BOOLEAN receive(srckey,uf,nbytes)
int srckey;
char *uf;
int nbytes;
{
	int sndsid,rcvsid,segid;
	char *addr;

	if (!findinfo(srckey,&sndsid,&rcvsid,&addr,&segid))
		return(FALSE);
	if (nbytes>MAXMSG)
		nbytes=MAXMSG;
	P(rcvsid);
	memcpy(uf,addr,nbytes);
	V(sndsid);
	return(TRUE);
}

void rmqueue(key)
int key;
{
	int sndsid,rcvsid,segid;
	char *addr;

	if (!findinfo(key,&sndsid,&rcvsid,&addr,&segid))
		syserr("findinfo");
	(void)semctl(sndsid,0,IPC_RMID,0);
	(void)semctl(rcvsid,0,IPC_RMID,0);
	(void)shmdt(addr);
	(void)shmctl(segid,IPC_RMID,0);
}

